#!/usr/bin/php
<?php
require_once ('boUtil.php');
require_once ('boDb.php');

class boDbTest extends boDb {
    function __construct($text) {
        // Let the parent handle construction. 
        parent::__construct($text); 
    }
    
    function testCalcStableMaxTime()
    {
        $t = getStartNsAndTimeString();
        $start_ns = $t["start_ns"];
        $end_ns = $t["end_ns"];
        var_dump($end_ns);
        $stableEndTime = $this->_calcStableMaxTime($end_ns);
        var_dump($stableEndTime);
    }

    function testGetSumOfStrokesPerChannel() {
    // TODO: make generic usable
//        $t = getStartNsAndTimeString();
//        $start_ns = $t["start_ns"];
//        $end_ns = $t["end_ns"];
        $start_ns = 1525132800000000000;
        $end_ns = 1527811200000000000;
        $execTime = 0;
        $execTimeReference = 0;
        $t1 = microtime(true);
        $result = $this->getSumOfStrokesPerChannel($start_ns, $end_ns, true);
        $t2 = microtime(true);
        $reference = $this->_getSumOfStrokesPerChannel($start_ns, $end_ns);
        $t3 = microtime(true);
        $execTime += $t2 - $t1;
        $execTimeReference += $t3 - $t2;
        if ($result == $reference) {
            print("passed; fast=$execTime sec, reference=$execTimeReference sec\n");
        } else {
            print("failed\n");
            var_dump($result);
            var_dump($reference);
        }
        print("fast=$execTime sec, reference=$execTimeReference sec\n");
    }

    function testGetSumOfSignalsPerChannel() {
    // TODO: make generic usable
//        $t = getStartNsAndTimeString();
//        $start_ns = $t["start_ns"];
//        $end_ns = $t["end_ns"];
        $start_ns = 1525132800000000000;
        $end_ns = 1527811200000000000;
        $execTime = 0;
        $execTimeReference = 0;
        $t1 = microtime(true);
        $result = $this->getSumOfSignalsPerChannel($start_ns, $end_ns, true);
        $t2 = microtime(true);
        $reference = $this->_getSumOfSignalsPerChannel($start_ns, $end_ns);
        $t3 = microtime(true);
        $execTime += $t2 - $t1;
        $execTimeReference += $t3 - $t2;
        if ($result == $reference) {
            print("passed; fast=$execTime sec, reference=$execTimeReference sec\n");
        } else {
            print("failed\n");
            var_dump($result);
            var_dump($reference);
        }
        print("fast=$execTime sec, reference=$execTimeReference sec\n");
    }

    function testGetMinMaxStrokeDistance() {
        $t = getStartNsAndTimeString();
        $start_ns = $t["start_ns"];
        $end_ns = $t["end_ns"];
        $execTime = 0;
        $execTimeReference = 0;
        for($i=0; $i<count(CHANNEL_NUMBER); $i++) {
            $c = CHANNEL_NUMBER[$i];
            $t1 = microtime(true);
            $result = $this->getMinMaxStrokeDistance($c, $start_ns, $end_ns);
            $t2 = microtime(true);
            $reference = $this->_getMinMaxStrokeDistance($c, $start_ns, $end_ns);
            $t3 = microtime(true);
            $execTime += $t2 - $t1;
            $execTimeReference += $t3 - $t2;
            if ($result == $reference) {
                print("channel $c passed; fast=$execTime sec, reference=$execTimeReference sec\n");
            } else {
                print("channel $c failed\n");
                var_dump($result);
                var_dump($reference);
            }
        }
        print("fast=$execTime sec, reference=$execTimeReference sec\n");
    }

    function testGetSumOfStrokesPerDistancePerChannel() {
        $t = getStartNsAndTimeString();
        $start_ns = $t["start_ns"];
        $end_ns = $t["end_ns"];
        $execTime = 0;
        $execTimeReference = 0;

        $maxDistance = 0; // the maximum distance of all channels
        for($i=0; $i<count(CHANNEL_NUMBER); $i++) {
            $c = CHANNEL_NUMBER[$i];
            $t1 = microtime(true);
            $result = $this->getMinMaxStrokeDistance($c, $start_ns, $end_ns);
            if ($result["max"] > $maxDistance) {
                $maxDistance = $result["max"];
            }
        }    

        $stepWidth = 100; // step width of the distance in km
        for ($d = 0; $d < $maxDistance; $d += $stepWidth) {
            $t1 = microtime(true);
            $result = $this->getSumOfStrokesPerDistancePerChannel($d, $d + $stepWidth, $start_ns, $end_ns);
            $t2 = microtime(true);
            $reference = $this->_getSumOfStrokesPerDistancePerChannel($d, $d + $stepWidth, $start_ns, $end_ns);
            $t3 = microtime(true);
            $execTime += $t2 - $t1;
            $execTimeReference += $t3 - $t2;
            if ($result == $reference) {
                print("distance $d passed; fast=$execTime sec, reference=$execTimeReference sec\n");
            } else {
                print("distance $d failed\n");
                var_dump($result);
                var_dump($reference);
            }
        }
        print("fast=$execTime sec, reference=$execTimeReference sec\n");
    }

    function testGetStrokePositionForChannels() {
        die("TODO\n");
    }
}

// This function pareses the command line parameters and assigns default values for non-present parameters.
// in: -
// out:
//   1) In case of success: An array with the command line parameters as key and the assigned values.
//   2) Else: The intended usage is shown on stdout. The program terminates.
function parseOptions() {
    global $options;

    // define the options
    $shortopts = "t:"; // test
    $longopts  = array("help");

    // get the options from the command line
    $options = getopt($shortopts, $longopts);
    if (array_key_exists('help', $options)) printUsage();

    // test
    if (array_key_exists('t', $options)) {
        $options['t'] = intval($options['t']);
    } else {
        printUsage();
    }

    return($options);
}

function printUsage() {
    // print help screen
    $help  = "Usage:\n";
    $help .= "-t<test number>\n";
    $help .= "-t0 = test calcStableMaxTime()\n";
    $help .= "-t1 = test getSumOfStrokesPerChannel()\n";
    $help .= "-t2 = test getSumOfSignalsPerChannel()\n";
    $help .= "-t3 = test getMinMaxStrokeDistance()\n";
    $help .= "-t4 = test getSumOfStrokesPerDistancePerChannel()\n";
    $help .= "-t5 = test getStrokePositionForChannels()\n";
    die($help);
}

// This function acts as a dispatcher for the commands received from the command line.
function main() {
    // get the command line options and assign them to nicely named variables
    $options = parseOptions();
    if (1 == count($options)) {
        $test = $options["t"];
    } else {
        printUsage();
    }

    // open an instance of the database tester (which will automatically close when leavng main)
    $dbt = new boDbTest(getCommandLine());
    
    // command dispatcher
    switch ($test) {
        case 0: $dbt->testCalcStableMaxTime(); break;
        case 1: $dbt->testGetSumOfStrokesPerChannel(); break;
        case 2: $dbt->testGetSumOfSignalsPerChannel(); break;
        case 3: $dbt->testGetMinMaxStrokeDistance(); break;
        case 4: $dbt->testGetSumOfStrokesPerDistancePerChannel(); break;
        case 5: $dbt->testGetStrokePositionForChannels(); break;
        default: printUsage();
    }
}

// the main function is called
main();
?>