#!/bin/sh
SCRIPT_PATH="$(dirname "$0")"
cd $SCRIPT_PATH
. ./boConfig.sh

# prevent script being started twice by checking/creating a PID file
if [ -f $FTP_LOCK_FILE ]
then
    PID=$(cat $FTP_LOCK_FILE)
    ps -p $PID > /dev/null 2>&1
    if [ $? -eq 0 ]
    then
        echo "Job is already running"
        exit 1
    else
        ## Process not found assume not running
        echo $$ > $FTP_LOCK_FILE
        if [ $? -ne 0 ]
        then
            echo "Could not create PID file"
            exit 1
        fi
    fi
else
    echo $$ > $FTP_LOCK_FILE
    if [ $? -ne 0 ]
    then
        echo "Could not create PID file"
        exit 1
    fi
fi

# do the actual work
python ./boGenerateImages.py
ls -l $FTP_LOCAL_PATH

wput -nc -u --binary --basename=$FTP_LOCAL_PATH/ $FTP_LOCAL_PATH/IMG*.png ftp://$FTP_USER:$FTP_PASS@$FTP_HOST/$FTP_REMOTE_PATH/
wput -nc -u --binary --basename=$FTP_LOCAL_PATH/ $FTP_LOCAL_PATH/index.html ftp://$FTP_USER:$FTP_PASS@$FTP_HOST/$FTP_REMOTE_PATH/

# cleanup the PID file
rm $FTP_LOCK_FILE

